Summary: A general purpose sound file conversion tool
Name: sox
Version: 14.4.1
Release: 1
License: GPLv2+ and LGPLv2+
Group: Applications/Multimedia
URL: http://sox.sourceforge.net/
Source0: %{name}/%{name}-%{version}.tar.bz2
Patch0: %{name}-mcompand_clipping.patch
Patch1: %{name}-%{version}-aix.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot

BuildRequires: patch
BuildRequires: gcc >= 4.2.3-2

BuildRequires: file-devel >= 5.05-2
BuildRequires: flac-devel >= 1.2.1-3
BuildRequires: lame-devel >= 3.98.4-1
BuildRequires: libao-devel >= 0.8.8-1
BuildRequires: libgomp >= 4.2.3-2
BuildRequires: libid3tag-devel >= 0.15.1b-3
BuildRequires: libmad-devel >= 0.15.1b-1
BuildRequires: libogg-devel >= 1.1.4-1
BuildRequires: libpng-devel >= 1.2.46-1
BuildRequires: libsndfile-devel >= 1.0.21-1
BuildRequires: libvorbis-devel >= 1.3.1-1
BuildRequires: opencore-amr-devel >= 0.1.2-1
BuildRequires: twolame-devel >= 0.3.13-1
BuildRequires: wavpack-devel >= 4.60.1-1
BuildRequires: zlib-devel >= 1.2.3-3

Requires: file-libs >= 5.05-2
Requires: flac >= 1.2.1-3
Requires: lame >= 3.98.4-1
Requires: libao >= 0.8.8-1
Requires: libgomp >= 4.2.3-2
Requires: libid3tag >= 0.15.1b-3
Requires: libmad >= 0.15.1b-1
Requires: libogg >= 1.1.4-1
Requires: libpng >= 1.2.46-1
Requires: libsndfile >= 1.0.21-1
Requires: libvorbis >= 1.3.1-1
Requires: opencore-amr >= 0.1.2-1
Requires: twolame >= 0.3.13-1
Requires: wavpack >= 4.60.1-1
Requires: zlib >= 1.2.3-3

%define _libdir64 %{_prefix}/lib64

%description
SoX (Sound eXchange) is a sound file format converter SoX can convert
between many different digitized sound formats and perform simple
sound manipulation functions, including sound effects.

The library is available as 32-bit and 64-bit.


%package devel
Summary: The SoX sound file format converter libraries
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkg-config
Requires: file-devel >= 5.05-2
Requires: flac-devel >= 1.2.1-3
Requires: lame-devel >= 3.98.4-1
Requires: libao-devel >= 0.8.8-1
Requires: libgomp >= 4.2.3-2
Requires: libid3tag-devel >= 0.15.1b-3
Requires: libmad-devel >= 0.15.1b-1
Requires: libogg-devel >= 1.1.4-1
Requires: libpng-devel >= 1.2.46-1
Requires: libsndfile-devel >= 1.0.21-1
Requires: libvorbis-devel >= 1.3.1-1
Requires: opencore-amr-devel >= 0.1.2-1
Requires: twolame-devel >= 0.3.13-1
Requires: wavpack-devel >= 4.60.1-1
Requires: zlib-devel >= 1.2.3-3

%description devel
This package contains the library needed for compiling applications
which will use the SoX sound file format converter.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc -q64" or "gcc -maix64".


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH
%patch0 -p1 -b .clip
%patch1
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CFLAGS="-DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export CC="gcc -maix64 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES"
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export CC="gcc -maix32 -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%doc 32bit/AUTHORS 32bit/ChangeLog 32bit/COPYING 32bit/README
%{_bindir}/*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_mandir}/man1/*
%{_mandir}/man7/*
/usr/bin/*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/sox.pc
%{_libdir64}/pkgconfig/sox.pc
%{_mandir}/man3/*
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Mon Dec 16 2013 Michael Perzl <michael@perzl.org> - 14.4.1-1
- first version for AIX V5.1 and higher
